import chimera, numpy as np
from StructBio.Scenographics.solids import Solids
from StructBio.Scenographics.parametricSurfaces import RuledSurface

chimera.runCommand("set bg_color white")


# Ruffle

numFirstPts = 1024
numCrossSections = 2

thetaIncr = 2.0*np.pi/numFirstPts
thetaVals_L = [i*thetaIncr for i in range(numFirstPts)]
firstPts_L = [np.array([np.cos(theta), np.sin(theta), 0.2*np.sin(32.*theta)]) for theta in thetaVals_L]
finalPts_L = [np.array([.4 * np.cos(theta), .4 * np.sin(theta), 0.0]) for theta in thetaVals_L]

# Variation: Final section is a single point:
#finalPts_L = [np.array([0., 0., -0.]) for i in range(numFirstPts)]

# Show a set of small spheres to represent points in base and final cross sections:
spheres = Solids()
for pt in firstPts_L: spheres.addSphere(pt, .015, (1.0, 0., 0,))
for pt in finalPts_L: spheres.addSphere(pt, .02, (1.0, 0., 0,))
spheres.display()

ruledSurf = RuledSurface(firstPts_L, finalPts_L, numCrossSections)

#ruledSurf.displayMesh((0., 1., 0.), closed = True, startCap = False, endCap = False)
ruledSurf.displaySurface((.14, .21, .56), transparency = .2, closed = True, startCap = False, endCap = False)

chimera.runCommand("focus")
 
